//@ sourceURL=emergencias.js  
jQuery(function($){
	initRupI18nPromise.then(function() {
		prepareData();		
	});
	
	function prepareData(){
	
	
		$("#maestroEmergencias_idTipoEmergencia46_filter_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			selected:''
		});
		$.rup_date({
			//yearRange: 'c-100:c+0',
	        from: "fEmergencia27Desde_filter_table",
	        to: "fEmergencia27Hasta_filter_table",
	        mask: 'dd/mm/yyyy',
			showButtonPanel : true,
			showOtherMonths : true,
			noWeekend : true
	     });
		const fecha = new Date();
		const anoActual = fecha.getFullYear();
		$("#fEmergencia27Desde_filter_table").rup_date("setRupValue", "01/01/"+anoActual);
		
		$("#emergencias_filter_form").rup_validate({
		    liveCheckingErrors: false,
		    showFieldErrorAsDefault: true,
		    showErrorsInFeedback: true,
		    showFieldErrorsInFeedback: true,
		    rules:{
		    	"fEmergencia27Desde":{required:true,date:true},
		    	"fEmergencia27Hasta":{date:true}
		    }
		});
		
		$("#emergencias_filter_form [ruptype='date']").blur(function(elem) { 

			if(!$(elem.target).valid()){
                $(elem.target).val('')
            }

		})
		/*DOMICILIOS*/
		if($("#idprovincia06_avisos_dialog_table").length == 1){			
			$("#idprovincia06_avisos_dialog_table").rup_combo({
				source:  $.rup.CTX_PATH + 'nora/provincias',
				sourceParam: {label: "descProvincia", value:"codProvincia"},
				rowStriping: true,
				width: 'auto',
				blank: '',
				customClasses: ['select-material'],
				change: function(){
					
				},
				selected: (function(){ try { return solicitantes.direcciones.idProvincia06} catch { return null}})()
			});
			
			
		}
	
	
		if($("#idmunicipio06_avisos_dialog_table").length == 1){
			//MUNICIPIO
			$("#idmunicipio06_avisos_dialog_table").rup_combo({
				parent: ["idprovincia06_avisos_dialog_table"],			
				source: $.rup.CTX_PATH + 'nora/municipioEnlazado',
				sourceParam: {label: "descripcion", value:"codMunicipio"},
				rowStriping: true,
				width: 'auto',
				blank: '',
				customClasses: ['select-material'],
				change: function(){
					
				},
				selected: (function(){ try { return solicitantes.direcciones.idMunicipio06} catch { return null}})()
			});
		}
		
		
		
		
		
		
		
		let tableColModels = [	
				{ 	name: "solicitante.identificador01",
					index: "solicitante.identificador01",
					editable: true, 
					hidden: false
				},			
				{ 	name: "solicitante.nombre01",
					index: "solicitante.nombre01",
					editable: true, 
					hidden: false
				},
				{ 	name: locale=='Es'?"maestroEmergencias.descEs46":'maestroEmergencias.descEu46',
					index: locale=='Es'?"maestroEmergencias.descEs46":'maestroEmergencias.descEu46',
					editable: true, 
					hidden: false
				},
				{ 	name: "fEmergencia27",
					index: "fEmergencia27",
					editable: true, 
					hidden: false
				},
				{ 	name: "recMovilEmers",
					index: "recMovilEmers",
					editable: true, 
					hidden: false
				},
				{ 	name: 'solicitante.direcciones.provinciaNORA.descProvincia',
					index: 'solicitante.direcciones.provinciaNORA.descProvincia',
					editable: true, 
					hidden: false
				},
				{ 	name: 'solicitante.direcciones.municipioNORA.descripcion',
					index: 'solicitante.direcciones.municipioNORA.descripcion',
					editable: true, 
					hidden: false
				},
				
				
				];
	
		let columnDefs = [ 
			
			{ 
				"targets": 4,
				"render": function(data, type, row, settings){	
					if( data !=null ){
						let recursos = "";
						data.forEach( (mov) => {
							let movText = "";
							switch (mov.recursoMovilizado28) {
								case RECURSOMOVILIZADO_FAMILIARESVal:
									movText = RECURSOMOVILIZADO_FAMILIARESDesc;
									break;
								case RECURSOMOVILIZADO_UMPROPIAVal:
									movText = RECURSOMOVILIZADO_UMPROPIADesc;
									break;
								case RECURSOMOVILIZADO_UMSOPORTEVal:
									movText = RECURSOMOVILIZADO_UMSOPORTEDesc;
									break;
								case RECURSOMOVILIZADO_SOSDEIAKVal:
									movText = RECURSOMOVILIZADO_SOSDEIAKDesc;
									break;
								case RECURSOMOVILIZADO_CSVal:
									movText = RECURSOMOVILIZADO_CSDesc;
									break;
								default: 
									movText = '---';
									break;
		
							}
							recursos += `<li>${movText}</li>`; 
						});
						
						return `<ul style="margin-left: 0;padding-left: 0;list-style: circle;">${recursos}</ul>`;
					}
					return '';
				}
			},
			{ 
				"targets": 1,
				"render": function(data, type, row, settings){	
					let nombreCompleto="";
					if(row.solicitante.nombre01!=null){
						nombreCompleto+=row.solicitante.nombre01;
					}
					if(row.solicitante.apellido101!=null){
						nombreCompleto+=" "+row.solicitante.apellido101;
					}
					if(row.solicitante.apellido201!=null){
						nombreCompleto+=" "+row.solicitante.apellido201;
					}
					
					return nombreCompleto;
			}
			}
		];
		$("#emergencias").rup_table({
			colReorder: {
			 fixedColumnsLeft: 1
			}
			,colModel: tableColModels
			,columnDefs : columnDefs
			,primaryKey: "idEmergencia27"
			,filter:{
	  	  		id:"emergencias_filter_form",
	  	  		filterToolbar:"emergencias_filter_toolbar",
	  	  		collapsableLayerId:"emergencias_filter_fieldset",
	  	  		showHidden: true
	     	}
			,noEdit : true
	   		,select: {
	       		activate: true
	   		}
			,buttons: {
				activate: true,
				contextMenu: false,
				blackListButtons: ['addButton', 'editButton', 'cloneButton', 'copyButton','deleteButton','pdfButton', 'odsButton', 'csvButton'],
			},
			columnOrderArrows: {
			    showOnlyActive: false,
			    display: 'inline'
			}
			,order: [[0, "asc"]]
		});
	}
});